A **Matching** in a graph **G = (V, E)** is a subset **M** of **E** edges in **G** such that no two of which meet at a common vertex.

**Maximum Cardinality Matching (MCM)** problem is a Graph Matching problem where we seek a matching **M** that contains the largest possible number of edges. A desirable but rarely possible result is **Perfect Matching** where all |**V**| vertices are matched (assuming |**V**| is even), i.e., the cardinality of **M** is |**V**|**/2**.

A **Bipartite Graph** is a graph whose vertices can be partitioned into two disjoint sets **U** and **V** such that every edge can only connect a vertex in **U** to a vertex in **V**.

**Maximum Cardinality Bipartite Matching (MCBM)** problem is the **MCM** problem in a Bipartite Graph, which is a lot easier than **MCM** problem in a General Graph.

**Remarks**: By default, we show e-Lecture Mode for first time (or non logged-in) visitor.

If you are an NUS student and a repeat visitor, please __login__.

Graph Matching problems (and its variants) arise in various applications, e.g.,

- The underlying reason on why
__Social Development Network__exists in Singapore - Matching job openings (one disjoint set) to job applicants (the other disjoint set)
- The weighted version of #2 is called the
__Assignment problem__ - Special-case of some NP-hard optimization problems

(e.g.,__MVC__, MIS, MPC on DAG, etc) - Sub-routine of Christofides's 1.5-approximation algorithm for
__TSP__, etc...

Pro-tip 1: Since you are not __logged-in__, you may be a first time visitor (or not an NUS student) who are not aware of the following keyboard shortcuts to navigate this e-Lecture mode: **[PageDown]**/**[PageUp]** to go to the next/previous slide, respectively, (and if the drop-down box is highlighted, you can also use **[→ or ↓/← or ↑]** to do the same),and **[Esc]** to toggle between this e-Lecture mode and exploration mode.

In some applications, the weights of edges are not uniform (1 unit) but varies, and we may then want to take MCBM or MCM with minimum (or even maximum) total weight.

However, this visualization is currently limited to unweighted graphs only. Thus, we currently do not support Graph Matching problem variants involving weighted graphs...

Pro-tip 2: We designed this visualization and this e-Lecture mode to look good on 1366x768 resolution **or larger** (typical modern laptop resolution in 2021). We recommend using Google Chrome to access VisuAlgo. Go to full screen mode (**F11**) to enjoy this setup. However, you can use zoom-in (**Ctrl +**) or zoom-out (**Ctrl -**) to calibrate this.

To switch between the unweighted **MCBM** (default, as it is much more popular) and unweighted **MCM** mode, click the respective header.

Here is an example of **MCM** mode. In **MCM** mode, one can draw a **General**, not necessarily **Bipartite** graphs. However, the graphs are unweighted (all edges have uniform weight 1).

The available algorithms are different in the two modes.

Pro-tip 3: Other than using the typical media UI at the bottom of the page, you can also control the animation playback using keyboard shortcuts (in Exploration Mode): **Spacebar** to play/pause/replay the animation, **←**/**→** to step the animation backwards/forwards, respectively, and **-**/**+** to decrease/increase the animation speed, respectively.

You can view the visualisation here!

For **Bipartite Graph** visualization, we will mostly layout the vertices of the graph so that the two disjoint sets (**U** and **V**) are clearly visible as Left (**U**) and Right (**V**) sets. When you draw your input bipartite graph, you can choose to re-layout your bipartite graph into this easier-to-visualize form.

For **General Graph**, we do not (and usually cannot) relayout the vertices into this Left Set and Right Set form.

Initially, edges have grey color. Matched edges will have black color. Free/Matched edges along an augmenting path will have Orange/Light Blue colors, respectively.

There are three different sources for specifying an input graph:

**Draw Graph**: You can draw**any**undirected unweighted graph as the input graph.

However, due to the way we visualize our MCBM algorithms, we need to impose one additional graph drawing constraint that does not exist in the actual MCBM problems. That constraint is that vertices on the left set are numbered from [0, n), and vertices on the right set are numbered from [n, n+m).**Modeling**: Several graph problems can be reduced into an**MCBM**problem. In this visualization, we have the modeling examples for the famous Rook Attack problem and standard**MCBM**problem (also valid in**MCM**mode).**Examples**: You can select from the list of our example graphs to get you started. The list of examples is slightly different in the two**MCBM**vs**MCM**modes.

There are several Max Cardinality Bipartite Matching (MCBM) algorithms in this visualization, plus one more in Max Flow visualization:

- By reducing MCBM problem into a Max-Flow problem in polynomial time,

we can actually use any Max Flow algorithm to solve MCBM. - O(
**VE**)**Augmenting Path Algorithm**(without greedy pre-processing), - O(
**√(V)E**)**Dinic's**or**Hopcroft-Karp Algorithm**, - O(
**kE**)**Augmenting Path Algorithm**(with randomized greedy pre-processing),

PS1: Although possible, we will likely not use O(**V ^{3}**)

**Edmonds' Matching Algorithm**if the input is guaranteed to be a

**Bipartite Graph**(as it is much slower).

PS2: Although possible, we will also likely not use O(**V ^{3}**)

**Kuhn-Munkres Algorithm**(not available in VisuAlgo yet) if the input is guaranteed to be an

**unweighted**Bipartite Graph (again, as it is much slower).

The **MCBM** problem can be modeled (or reduced into) as a Max Flow problem in polynomial time.

Go to __Max Flow__ visualization page and see the flow graph modeling of MCBM problem (select Modeling → Bipartite Matching → all 1). Basically, create a super source vertex **s** that connects to all vertices in the left set and also create a super sink vertex **t** where all vertices in the right set connect to **t**. Keep all edges in the flow graph **directed** from source to sink and with unit weight 1.

If we use one of the earliest Max Flow algorihtm, i.e., a simple Ford-Fulkerson algorithm, it will still be much faster than O(**mf × E**) as all edge weights in the flow graph are unit weight, i.e., in O(**E^2**).

If we use one of the fastest Max Flow algorithm, i.e., Dinic's algorithm on this flow graph, we can find Max Flow = MCBM in O(**√(V)E**) time — __the analysis is omitted for now__. This allows us to solve MCBM problem with **V** ∈ [1000..1500] in a typical 1s allowed runtime in many programming competitions.

Discussion: The edges in the flow graph must be directed. Why?

Then prove that this reduction is correct.

The content of this interesting slide (the answer of the usually intriguing discussion point from the earlier slide) is hidden and only available for legitimate CS lecturer worldwide. This mechanism is used in the various __flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

Actually, we can just stop here, i.e., when given any MCBM(-related) problem, we can simply reduce it into a Max-Flow problem and use (the fastest) Max Flow algorithm.

However, there is a far simpler Graph Matching algorithm that we will see in the next few slides. It is based on a crucial theorem and can be implemented as an easy variation of the standard Depth-First Search (DFS) algorithm.

**Augmenting Path** is a path that starts from a free (unmatched) vertex **u** in graph **G** (note that **G** does not necessarily has to be a bipartite graph although augmenting path, if any, is much easier to find in a bipartite graph), alternates through unmatched (or free/'f'), matched (or 'm'), ..., unmatched ('f') edges in **G**, until it ends at another free vertex **v**. The pattern of any Augmenting Path will be fmf...fmf and is of odd length.

If we flip the edge status along that augmenting path, i.e., fmf...fmf into mfm...mfm, we will increase the number of edges in the matching set **M** by exactly 1 unit and eliminates this augmenting path.

In 1957, Claude Berge proposes the following __theorem__:*A matching M in graph G is maximum iff there is no more augmenting path in G*.

Discussion: In class, prove the correctness of Berge's theorem!

In practice, we can just __use it verbatim__.

The content of this interesting slide (the answer of the usually intriguing discussion point from the earlier slide) is hidden and only available for legitimate CS lecturer worldwide. This mechanism is used in the various __flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

The content of this interesting slide (the answer of the usually intriguing discussion point from the earlier slide) is hidden and only available for legitimate CS lecturer worldwide. This mechanism is used in the various __flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

Recall: Berge's theorem states:*A matching M in graph G is maximum iff there is no more augmenting path in G*.

The **Augmenting Path Algorithm** (on Bipartite Graph) is a simple O(**V*(V+E)**) = O(**V ^{2} + VE**) = O(

**VE**) implementation (a modification of DFS) of that theorem: Find and then eliminate augmenting paths in Bipartite Graph

**G**.

Click

to visualize this algorithm on a special test case called X̄ (X-bar).Basically, this Augmenting Path Algorithm scans through all vertices on the left set (that were initially free vertices) one by one. Suppose **L** on the left set is a free vertex, this algorithm will recursively (via modification of DFS) go to a vertex **R** on the right set:

- If
**R**is another free vertex, we have found one augmenting path (e.g., Augmenting Path 0-2 initially), and - If
**R**is already matched (this information is stored at**match[R]**), we immediately return to the left set and recurse (e.g, path 1-2-immediately return to 0-then 0-3, to find the second Augmenting Path 1-2-0-3)

vi match, vis; // global variables

int Aug(int L) { // notice similarities with DFS algorithm

if (vis[L]) return 0; // L visited, return 0

vis[L] = 1;

for (auto& R : AL[L])

if ((match[R] == -1) || Aug(match[R])) { // the key modification

match[R] = L; // flip status

return 1; // found 1 matching

}

return 0; // Augmenting Path is not found

}

// in int main(), build the bipartite graph

// use directed edges from left set (of size VLeft) to right set

int MCBM = 0;

match.assign(V, -1);

for (int L = 0; L < VLeft; ++L) { // try all left vertices

vis.assign(VLeft, 0);

MCBM += Aug(L); // find augmenting path starting from L

}

printf("Found %d matchings\n", MCBM);

Please see the full implementation at Competitive Programming book repository: __mcbm.cpp__ | __py__ | __java__ | __ml__.

If we are given a **Complete** Bipartite Graph **K _{N/2,N/2}**, i.e.,

**V = N/2+N/2 = N**and

**E = N/2×N/2 = N**, then

^{2}/4 ≈ N^{2}the Augmenting Path Algorithm discussed earlier will run in O(

**VE**) = O(

**N×N**) = O(

^{2}**N**).

^{3}This is only OK for **V** ∈ [400..500] in a typical 1s allowed runtime in many programming competitions.

Try executing the **standard** Augmenting Path Algorithm on this , which is an almost complete **K _{5,5}** Bipartite Graph.

It feels bad, especially on the latter iterations...

So, should we avoid using this simple Augmenting Path algorithm?

The key idea of Hopcroft-Karp (HK) Algorithm (invented in 1973) is identical to __Dinic's Max Flow Algorithm__, i.e., prioritize shortest augmenting paths (in terms of number of edges used) first. That's it, augmenting paths with 1 edge are processed first before longer augmenting paths with 3 edges, 5 edges, 7 edges, etc (the length always increase by 2 due to the nature of augmenting path in a Bipartite Graph).

Hopcroft-Karp Algorithm has time complexity of O(**√(V)E**) — __analysis omitted for now__. This allows us to solve MCBM problem with **V** ∈ [1000..1500] in a typical 1s allowed runtime in many programming competitions — the similar range as with running Dinic's algorithm on Bipartite Matching flow graph.

Try HK Algorithm on the same **VE**) Augmenting Path Algorithm.

Since Hopcroft-Karp algorithm is essentially also Dinic's algorithm, we treat both as 'approximately equal'.

However, we can actually make the easy-to-code **Augmenting Path Algorithm** __discussed earlier__ to avoid its worst case O(**VE**) behavior by doing O(**V+E**) randomized (to avoid adversary test case) greedy pre-processing *before* running the actual algorithm.

This O(**V+E**) additional pre-processing step is simple: For every vertex on the left set, match it with a *randomly chosen* unmatched neighbouring vertex on the right set. This way, we eliminate many trivial (one-edge) Augmenting Paths that consist of a free vertex **u**, an unmatched edge **(u, v)**, and a free vertex **v**.

Try Augmenting Path Algorithm Plus on the same

earlier. Notice that the pre-processing step already eliminates many trivial 1-edge augmenting paths, making the actual Augmenting Path Algorithm only need to do little amount of additional work.Quite often, on **randomly generated** Bipartite Graph, the randomized greedy pre-processing step has cleared most of the matchings.

However, we can construct test case like: **Example Graphs, Corner Case, Rand Greedy AP Killer** to make randomization as ineffective as possible. For every group of 4 vertices, there are 2 matchings. Random greedy processing has 50% chance of making mistake per group (but since each group has only short Augmenting Paths, the fixes are not 'long'). Try this case to see for yourself.

The worst case time complexity is no longer O(**VE**) but now O(**kE**) where **k** is a small integer, much smaller than **V**, **k** can be as small as 0 and is at most **V/2** (any maximal matching, as with this case, has size of at least half of the maximum matching). In our *empirical experiments*, we estimate **k** to be "about √(**V**)" too. This version of Augmenting Path Algorithm Plus also allows us to solve MCBM problem with **V** ∈ [1000..1500] in a typical 1s allowed runtime in many programming competitions.

So, when presented with an MCBM problem, which route should we take?

- Reduce the MCBM problem into Max-Flow and use Dinic's algorithm (essentially Hopcroft-Karp algorithm) and gets
**O(√(V)E)**performance guarantee but with a much longer implementation? - Use Augmenting Path algorithm with Randomized Greedy Processing with
**O(kE)**performance with good empirical results and a much shorter implementation?

Discussion: Discuss these two routes!

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

__flipped classrooms__ in NUS.

**If you are really a CS lecturer (or an IT teacher)** (outside of NUS) and are interested to know the answers, please drop an email to stevenhalim at gmail dot com (**show your University staff profile/relevant proof to Steven**) for Steven to manually activate this CS lecturer-only feature for you.

FAQ: This feature will **NOT** be given to anyone else who is not a CS lecturer.

Unfortunately there is no weighted MCBM algorithm (e.g., Hungarian or Kuhn-Munkres) visualization in VisuAlgo *yet*. But the plan is to have this visualization eventually.

For this section, please refer to CP4 Book 2 Chapter 9.25 and 9.27.

When Graph Matching is posed on general graphs (the MCM problem), it is (much) harder to find Augmenting Path. In fact, before Jack Edmonds published his famous paper titled "Paths, Trees, and Flowers" in 1965, this MCM problem was thought to be an (NP-)hard optimization problem.

There are two Max Cardinality Matching (MCM) algorithms in this visualization:

- O(
**V^3**)**Edmonds' Matching**algorithm (without greedy pre-processing), - O(
**V^3**)**Edmonds' Matching**algorithm (with greedy pre-processing),

In General Graph, we may have Odd-Length cycle. Augmenting Path is not well defined in such a graph (see below), hence we cannot easily implement Claude Berge's theorem like what we did with Bipartite Graph.

Jack Edmonds call a path that starts from a free vertex **u**, alternates between free, matched, ..., free edges, and returns to the **same** free vertex **u** as a **Blossom**. This situation is only possible if we have Odd-Length cycle, i.e., in a non-Bipartite Graph. Edmonds then proposed __Blossom shrinking/contraction and expansion algorithm__ to solve this issue.

For details on how this algorithm works, read CP4 Section 9.28.

This algorithm can be implemented in O(**V^3**).

As with the **Augmenting Path Algorithm Plus** for the MCBM problem, we can also do randomized greedy pre-processing step to eliminate as many 'trivial matchings' as possible upfront. This reduces the amount of work of **Edmonds' Matching Algorithm**, thus resulting in a faster time complexity — analysis TBA.

We have not added the visualizations for weighted variant of **MCBM** and **MCM** problems. They are for future work. Among the two, **weighted MCBM** will likely be added earlier than the **weighted MCM** version.

One of the possible solution for **weighted MCBM** problem is the __Hungarian__ algorithm. This algorithm also has another name: The Kuhn-Munkres algorithm. This algorithm relies on Berge's Augmenting Path Theorem too, but it uses the theorem slightly differently.

To strengthen your understanding about these Graph Matching problem, its variations, and the multiple possible solutions, please try solving as many of these programming competition problems listed below:

- Standard MCBM (but need a fast algorithm):
__Kattis - flippingcards__ - Greedy Bipartite Matching:
__Kattis - froshweek2__

(you do**not**need a specific MCBM algorithm for this,

in fact, it will be too slow if you use any algorithm discussed here) - Special case of an NP-hard optimization problem:
__Kattis - TBA__ - Rather straightforward weighted MCBM:
__Kattis - engaging__

To tackle those programming contest problems, you are allowed to use/modify our implementation code for Augmenting Path Algorithm (with Randomized Greedy Preprocessing): __mcbm.cpp__ | __py__ | __java__ | __ml__

You have reached the last slide. Return to 'Exploration Mode' to start exploring!

Note that if you notice any bug in this visualization or if you want to request for a new visualization feature, do not hesitate to drop an email to the project leader: Dr Steven Halim via his email address: stevenhalim at gmail dot com.

__Tutup__

Edit Graph

Modeling

Graf-Graf Contoh

Augmenting Path